"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
require("mocha");
const ExampleCommand_1 = __importDefault(require("../Commands/ExampleCommand"));
const MOCK_MESSAGE = {
    channel: {
        send: (val) => Promise.resolve(val)
    }
};
describe('Test Command', () => {
    const command = new ExampleCommand_1.default([], [], [], false);
    it('Should have instantiated with no problem', () => {
        chai_1.expect(command).to.not.be.null;
        chai_1.expect(command).to.not.be.undefined;
    });
    it('Should have a name and namespace property', () => {
        chai_1.expect(command.Name()).to.be.a('string');
        chai_1.expect(command.Namespace()).to.be.a('string');
    });
    it('Should be able to run with no problems', async () => {
        const test = command.Run(MOCK_MESSAGE);
        chai_1.expect(test).to.be.a('Promise');
        const test2 = await test;
        chai_1.expect(test2).to.equal(ExampleCommand_1.default.TEST_OUTPUT);
    });
});
//# sourceMappingURL=Command.spec.js.map